SystemOrganization addCategory: #'Rizel-Builder'!

OrderedCollection subclass: #MVector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Builder'!

!MVector class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 6/24/2012 19:30'!
values: aCollection 
	| instance |
	instance := self new.
	instance addAll: aCollection.
	^ instance! !

!MVector methodsFor: 'comparing' stamp: 'JuanPabloSandovalA 6/24/2012 19:24'!
= aVector 
	| piv |
	self class = aVector class
		ifTrue: [self size = aVector size
			ifTrue: [
				piv := 1.
				self do: [:val | 
					val = (aVector at: piv) ifFalse: [^ false].
					piv := piv + 1].
			^ true]].
	^ false.! !

Object subclass: #MBuilder
	instanceVariableNames: 'inputs dimensions packagePattern'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Builder'!

!MBuilder methodsFor: 'combinations' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 12:54'!
combinations
	"return all combinations for inputs"
	^ self combinationsOf: inputs copy! !

!MBuilder methodsFor: 'combinations' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 12:55'!
combinationsOf: aCollectionOfInputs 
	"return all combiantions for aCollectionOfInputs"
	| subComb first result |
	result := OrderedCollection new.
	aCollectionOfInputs isEmpty
		ifTrue: [^ result].
	first := aCollectionOfInputs first.
	aCollectionOfInputs removeFirst.
	subComb := self combinationsOf: aCollectionOfInputs.
	first values
		do: [:val | subComb isEmpty
				ifTrue: [result add: (OrderedCollection new add: val;
							 yourself)]
				ifFalse: [subComb
						do: [:subVal | result add: (OrderedCollection new add: val;
									 addAll: subVal;
									 yourself)]]].
	^ result! !

!MBuilder methodsFor: 'inputs' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 12:30'!
define: aSymbol named: aString 
	"define a new dimension to the analisis"
	| variant |
	variant := self perform: aSymbol.
	variant name: aString.
	^ variant! !

!MBuilder methodsFor: 'inputs' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 12:30'!
define: aSymbol named: aString with: values 
	"define a new dimension named aString with values"
	| variant |
	variant := self define: aSymbol named: aString.
	variant values: values.
	^ variant! !

!MBuilder methodsFor: 'inputs' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 12:31'!
dimension
	"dimension factory method"
	| dimension |
	dimension := MInput new.
	inputs add: dimension.
	^ dimension! !

!MBuilder methodsFor: 'combinations' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 12:55'!
execute: block 
	"do a multimensional profiling"
	^ self execute: block in: MResultSet new! !

!MBuilder methodsFor: 'combinations' stamp: 'JuanPabloSandovalA 6/24/2012 17:02'!
execute: block in: result
	"execute the block with all convinations and save the profiles in result"
	self combinations do: [:args | 
			| profile |
			profile := [block valueWithArguments: args]
						on: Error
						do: [nil].
			result key: args value: profile]. 
	^ result.
		! !

!MBuilder methodsFor: 'profiling' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 12:29'!
getTimeAndCallGraph
	"return true if you want capture the execution time with message tally profiler"
	^ false! !

!MBuilder methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	dimensions := OrderedCollection new.
	inputs := OrderedCollection new! !

!MBuilder methodsFor: 'inputs' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 12:31'!
input
	"input factory method"
	| in |
	in := MInput new.
	inputs add: in.
	^ in! !

!MBuilder methodsFor: 'inputs' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 12:31'!
inputs
	"return all inputs in muldimensional context"
	^ inputs! !

!MBuilder methodsFor: 'inputs' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 12:31'!
inputsOf: aSymbol 
	"return all posible values for a input with simbol aSymbol"
	| result |
	result := inputs
				select: [:in | in name = aSymbol].
	result size = 0
		ifTrue: [^ nil].
	^ result anyOne values! !

!MBuilder methodsFor: 'hook' stamp: 'JuanPabloSandovalA 6/24/2012 21:53'!
load: version fromPackageCache: path
	"load cache version"
	| repo |
  	repo := MCDirectoryRepository new.
  	repo directory: (FileDirectory on: path).
  	version repositoryOverrides: (OrderedCollection with: repo).
  	version load.! !

!MBuilder methodsFor: 'hook' stamp: 'JuanPabloSandovalA 6/24/2012 21:30'!
merge: profileB with: profileA
	| names newClasses oldClasses packages|
	names := Set new.
	packages := OrderedCollection new.
	newClasses := profileA packages.
	oldClasses := profileB packages.
	names addAll: (newClasses collect:#packageName).
	names addAll: (oldClasses collect:#packageName).
	names do: [:name | 
			| a b|
			b := newClasses select: [:cls | cls packageName = name].
			b := b isEmpty ifTrue:[ nil ] ifFalse: [b anyOne].
			a := oldClasses select: [:cls | cls packageName = name].
			a := a isEmpty ifTrue:[ nil ] ifFalse: [a anyOne].
			packages add: (RzPackage old: a new: b owner: (RzMerge packages: packages))].
	^ packages.! !

!MBuilder methodsFor: 'profiling' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 12:30'!
profile: aBlock inPackagesMatching: regex 
	"profile the execution of the aBlock in packages that mach with regex expresion"
	^ self spyProfiler profile: aBlock inPackagesMatching: regex! !

!MBuilder methodsFor: 'profiling' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 12:30'!
spyProfiler
	"return the default spy profiler"
	^ MProfiler! !

Object subclass: #MDimension
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Builder'!

!MDimension class methodsFor: 'as yet unclassified' stamp: ''!
named: t1 
	| t2 |
	t2 := self new.
	t2 name: t1.
	^ t2! !

!MDimension methodsFor: 'accessing' stamp: ''!
name
	^ name! !

!MDimension methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/24/2012 19:01'!
name: aStringOrSymbol
	name := aStringOrSymbol! !

Object subclass: #MInput
	instanceVariableNames: 'name values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Builder'!

!MInput class methodsFor: 'as yet unclassified' stamp: ''!
named: t1 
	| t2 |
	t2 := self new.
	t2 name: t1.
	^ t2! !

!MInput methodsFor: 'accessing' stamp: ''!
addValue: t1 
	values add: t1! !

!MInput methodsFor: 'accessing' stamp: ''!
initialize
	super initialize.
	values := OrderedCollection new! !

!MInput methodsFor: 'accessing' stamp: ''!
name
	^ name! !

!MInput methodsFor: 'accessing' stamp: ''!
name: t1 
	name := t1! !

!MInput methodsFor: 'accessing' stamp: ''!
values
	^ values! !

!MInput methodsFor: 'accessing' stamp: ''!
values: t1 
	values := t1! !

Object subclass: #MResultSet
	instanceVariableNames: 'dictionary size keys values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Builder'!

!MResultSet methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/24/2012 19:27'!
at: key
	"return the value associate to the key"
	| collectionkey |
	collectionkey := key isCollection
				ifTrue: [key]
				ifFalse: [OrderedCollection new add: key;
						 yourself].
	^ dictionary at: (MVector values: collectionkey) ifAbsent: [ nil ].! !

!MResultSet methodsFor: 'accessing' stamp: ''!
initialize
	super initialize.
	dictionary := Dictionary new.
	size := -1.
	keys := OrderedCollection new.
	values := OrderedCollection new! !

!MResultSet methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/24/2012 19:29'!
key: key value: value
	"build a new association between key and value"
	size < 0
		ifTrue: [size := key size]
		ifFalse: [key size = size ifFalse: [^ false]].
	keys add: (MVector values: key).
	values add: value.
	dictionary at: (MVector values: key) put: value.
	^ true.! !

!MResultSet methodsFor: 'accessing' stamp: ''!
keys
	^ keys! !

!MResultSet methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/24/2012 19:28'!
maxValue: aBlock 
	^ values maxValue: aBlock! !

!MResultSet methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/24/2012 19:29'!
minValue: aBlock
	^ values minValue: aBlock! !

!MResultSet methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/24/2012 19:29'!
of: key
	"return the value associate to the key"
	| collectionkey |
	collectionkey := key isCollection
				ifTrue: [key]
				ifFalse: [OrderedCollection new add: key;
						 yourself].
	^ dictionary at: (MVector values: collectionkey) ifAbsent: [ nil ].! !

!MResultSet methodsFor: 'accessing' stamp: ''!
values
	^ values! !
